/* ==== help.c ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


/* This is just very preliminary, I've not really decided on the file
 format for help yet... */


#include <stdio.h>
#include "porrog_defs.h"

/* protos */
#include "memutils.h"
#include "crash.h"
#include "help.h"

void help_main()
{
   show_help("contents");
}

void show_help(char *section) /* section must have already been formatted*/
{
    unsigned char a,b;
    char *farray;
    int fsize;
    int count;
    FILE *fp;
    char fname[25];
    sprintf(fname,"%s.ifo",section);
    fp=fopen(fname,"r");

    fscanf(fp,"%c%c",a,b);
    fsize=(256*a)+b;
    farray=(char *)counting_malloc(MEM_STRING,fsize*sizeof(char));
    for(count=0;count<fsize;count++)
      *(farray+count)=getc(fp);


    counting_free(MEM_STRING,farray);
}

void format_help(char *section)
{
    unsigned char a,b;
    char r;
    int fsize;
    int count;
    FILE *fps;
    FILE *fpt;
    char ssource[25];
    char starget[25];
    sprintf(ssource,"%s.src",section);
    sprintf(starget,"%s.ifo",section);
    fps=fopen(ssource,"r");
    /* Read through chars of ssource to count how many there are.
       If we find more than 65280, give an error. */

    for(count=0; count<65290 && getc(fps)!=EOF ;count++);
    if (count>65279) crash(IO_ERROR); /* Source file too big */

    fsize=count;
    a=(fsize/256);
    b=fsize-(a*256);
    fpt=fopen(starget,"w");
    fprintf(fpt,"%c%c",a,b);

    rewind(fps);
    for(count=0;count<fsize;count++)
    {
      r=getc(fps);
      if(r==EOF) crash(FUNCTION_ERROR); /* For testing */
      putc(r,fpt);
    }
    fclose(ssource);fclose(starget);
}

