/* ==== C-foogrid.h ==== */
/* Typedefs and prototypes. For great chuddies, include this!*/
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */



typedef struct {
   int Xsize; /* As in width */
   int Ysize; /* As in height */
   long Tsize; /* Internal! Used for bounds checking. Leave it alone!*/
   void *Data; /* The actual data. You have to cast it. */
} foogrid;

foogrid *create_foogrid(int hgt,int wid, int tsize);
/* tsize  returned using sizeof() operator */

/*long foogrid_idx(foogrid *array, int y, int x);
 Just gives an index. But you have to pass the grid pointer
   for it to work out the shape. */
#define FOOGRID_IDX(array,y,x) ((x)+((y)*array->Xsize))

#ifdef CAREFUL
#undef FOOGRID_IDX
#define FOOGRID_IDX(array,y,x) (((x)>=array->Xsize||(y)>=array->Ysize)?bugger(REPTYPE_CODE,LOGLEVEL_FOOBAR,"FOOGRID_IDX macro: Coords outside grid"),crash(OUT_OF_BOUNDS),0:(x)+((y)*array->Xsize))
/* Tests bounds first */
#endif

/* void *access_foogrid(foogrid *array, int y, int x); */
/* Returns pointer to the element requested. But you can
   only do this if foogrid contains the size of the
   elements we use. I don't think we can do this. */

void free_foogrid(foogrid *array);

/* Hell, I'm just using this for my own personal use. I don't plan
   to use it anywhere where crashing due to programming errors
   would cause any security hole. I don't care. */

