/* ==== makemap_p.h ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


/* include mg_types.h before this?? */

/* Creates a complex tree-structure of rooms connected by tunnels
   in "map", which so far is just a single global :P 
    (actually, "map" is now going to *stay* that way).
   Now renamed in anticipation of a time when there'll be different
   types of level map, and given an argument so the structures are
   filled in in a level structure. */
void make_dmap(levelmap_t *this, int dir);

void remake_dmap(levelmap_t *this);
/* A bit  like make_dmap... but rather than using the algorithm
  to create a new, random map, it recreates the level based on
  the data structures stored in it already. Really just a
  wrapper function. */

levelmap_t *level_skel();
 /* Creates a levelmap_t with a levelstructs_t structure put in it */

int find_room(int x,int y);
 /* As find_area, but expects to find a room. If it doesn't find a room,
   returns -1. If it does, returns index of that room.
   Important for driving through an area on course towards a target room.
   If we hit an already accessible room, we try from there instead (as it
   will obviously be closer). If we hit a not-accessible room, we try
   to connect *to* there. But we can't connect to the point we found the
   room at, which might well be the corner of the room (not good).*/

void free_features();
/* Frees features found in tls (a global). Yes. */

