/* ==== monster.h ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

extern mobtype_t *first_mt;
extern int mt_nums;


void m_init(); /* Creates all the monster types, only called once. */

monster_t *add_mob(levelstructs_t *level,int x,int y,mobtype_t *mtype);
/* Creates an instance of a given mobtype, at coords of map.
   Monster has no inventory.*/

void new_mobtype(mobtype_t *space, char sym, char *name,char *desc);
/* Creates mobtype data in preallocated space. name and desc must be
   stored somewhere permanently.*/

void push_mtype(char sym,char *name);
/* Used by m_init() for adding monster types */

void move_mob(int dx, int dy, monster_t *mob);
/* Moves given monster by dx,dy */

void m_open_door(monster_t *mob, int dx,int dy);
/* mob opens door towards dx,dy */

void get_item(monster_t *mob,item_t *item);
/* Places item (single item) into monster's inventory*/

/* Removes top item from monster's inventory, return it
  as a single item (ie: with ->Next==NULL)*/
item_t *discard_item(monster_t *mob);

void m_die(levelstructs_t *level,monster_t *victim);
/* Replaces victim with a corpse appropriate to its type */

int m_whatamion(monster_t *mob);
/* Categorizes what sort of tile mob is standing on:
  0=tunnel regions, 1=room, 2=doorway */

int m_respect(monster_t *observer,monster_t *observed);
/* Returns the respect of one for the other. */
