/* ==== player_p.h ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* Now, the type is in player_t.h, this just has prototypes now */
/* All these are adapted from monster.h */

/*
monster_t *add_mob(foogrid *map,int y,int x,mobtype_t *mtype);
 Creates an instance of a given mobtype, at coords of map.
   Monster has no inventory.*/

/*
void new_mobtype(mobtype_t *space, char sym, char *name,char *desc);
 Creates mobtype data in preallocated space. name and desc must be
   stored somewhere permanently.*/

void init_player(levelmap_t *map,int x,int y);
/* Sets up the player data. What there is of it. */

void p_move(int dx, int dy); /* Doesn't need map??? */
/* Moves player by dx,dy */

void p_open_door();
/* Opens any doors around the player.
  SHOULD be changed to ask which door to open. */

void p_close_door();
/* Closes any doors around the player.
  SHOULD be changed to ask which door to close. */

void p_get_item(item_t *item);
/* Places item (single item) into player's inventory*/

/* Removes top item from monster's inventory, return it
  as a single item (ie: with ->Next==NULL)*/
/*item_t *p_discard_item();  Should CHOOSE it. */
/* Now: takes GIVEN item from your inventory. Returns nothing. */
void p_discard_item(item_t *item);

void p_pickup();
/* Higher level function that p_get_item. */

void p_drop();
/* Higher level function that does p_discard_item and place_item, etc*/

void p_try_upstairs(); /* NOTE: Should it return info? */
/* If the player is standing on PTL_STAIRSUP, checks the destination.
   If the destination is NULL, create the new level and set it as the
   destination. Go to the destination. */

void p_try_downstairs(); /* NOTE: Should it return info? */
/* Like p_try_upstairs()... but for PTL_STAIRSDOWN! */

int p_whatamion();
/* Like m_whatamion, but for player. */

void p_wield(item_t *item); /* WILL PROLLY CHANGE */

void p_trywield();
void p_trywear();
void p_tryunwield();
void p_tryunwear();
/* Prompts player for something to (un)equip, tries to do so if poss */

