/* ==== race_p.h ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */



/* racialmax is a race-specific figure that gives the ceiling for the stat
being calculated, for that race. Members of that race can't reach it, but
get asymptotically closer.
 "training" is an integer that starts off randomly, somewhere between
 25 and 100 for players, that there represents that player's initial
 capability in that field, equating to 33% to 66% of full capacity.
 Then, each time a player does something that the game feels would likely
 to make the player's stat increase, it is actually "training" that gets
 incremented by one.
 Don't know what (initial) range should be for monsters, but it should
 likely be able to increase. */
unsigned short global_scale_stat(unsigned short racialmax,unsigned short training);
