/* ==== ui.h ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


/* #include <string.h> */
#include <stdio.h> /* sprintf is in stdio.h??? */
/* Because most ui functions use sprintf, and most non-ui functions dont.*/


extern char strbuf[];
/* I'm now going to put in some *more* structures, but ones purely
   pertaining to map generation (well, at the moment, anyway) */
/* Er, why did I write that? Was that from elsewhere originally? do I care?*/


extern char *messages_ringbuffer[]; /* press ^P to read it */
extern unsigned short mrb_startidx;
extern unsigned short mrb_endidx;

/* Show HP, etc */
void draw_status();

/* px,py is coords of player. cornerx,cornery is coords of topleft corner*/
void draw_map(int cornerx,int cornery, int px,int py);
void show_messages(char *msg);
void show_mrb(); /* display old messages ringbuffer */
void free_mrb(); /* free all the messages from ringbuffer (end of game) */
void msg_window(char *msg); /* Being phased out to be replaced by above fn */
void display_heap(char *title,item_t *list);

/*asks you to give an inventory letter (? shows the inventory letters),
  returns ptr to the corresponding item. Now takes flag argument,
  that if set, allows player to use '-' key, for use with p_trywield().*/
item_t *prompt_for_inv_item(int flag); 
item_t *prompt_for_heap_item(item_t *list);
/*asks you to choose an item from a given heap, using letters for items
  which are shown one screenful at a time (supposing there's more than one).
  Then returns ptr to that item.*/


/* being moved from apply.c. Most container/item processing is still there,
the code in ui.c is mostly a wrapper with friendlier ui stuff than the
old version. */
void apply_container(item_t *container);

/* --- end of ui.h ---- */
