/* ==== race.c ==== */
/*  Part of the source of the program "Porrog", a roguelike game.
    Copyright (C) 2002-2003  Tom Barnes-Lawrence
    Current web address: www.angelfire.com/super2/duologue/
    Current email address: tomble@usermail.com
    Postal address: mind your own business

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


/* There's no different races yet. The player currently has just a
 single hard-coded race, but these functions are used to map the
 details of that race into the global stat scale. */

unsigned short global_scale_stat(unsigned short racialmax,unsigned short training)
{
   /* This function makes the output stat asymptotically approach racialmax,
   and starts off with output at 0 when training is 0. */
   /*With the constant at 50, the output is at 33% when training is 25,
   at 50% when training is 50, at 66% when training is 100,
   at 75% when training is 150, doesnt reach 90% till training is 450...
   When constant is lower, advancement is faster.
   In fact, looking further, SLOPECONSTANT is always the value of "training"
   at which the output is 50%! */
#define SLOPECONSTANT 50
   long numer=racialmax*SLOPECONSTANT;
   return(racialmax-(numer/(training+SLOPECONSTANT)));
}
